<template>
  <div id="Games">
    <!-- New game modal -->
    <ModalForm
      title="Create a new game"
      submitBtnText="Create"
      v-if="gameCreation"
      v-on:submit="createGame"
      v-on:cancel="gameCreation = false"
    >
      <span>
        Game name: <input type="text" v-model="newGameName" autofocus />
      </span>
    </ModalForm>

    <!-- Select game title and new game btn -->
    <div id="title" class="panel">
      <LogOutBtn/>
      <button @click="gameCreation = true">New game</button>
    </div>

    <!-- Game list -->
    <div id="gameList">
      <List
        :gatherFunction="$services.backends.games.getGames"
        title="Select a game"
        noItemMessage="Please create a game"
        refreshEventName="refreshGames"
        :refreshBtn="false"
      >
        <GameItem
          slot-scope="props"
          :game="props.item"
          v-on:play="play"
          v-on:delete="del"
        />
      </List>
    </div>
    <ModalConfirm ref="confMod" />
  </div>
</template>

<script lang="ts">
/**
 * @licence
 * Copyright 2022-2022 - RPG of the Apocalypse
 * Licensed under MIT or any later version
 * Refer to the LICENSE file included.
 */

import { Component, Vue } from "vue-property-decorator";
// Import components
import List from "../common/List.vue";
import ModalForm from "../common/ModalForm.vue";
import ModalConfirm from "../common/ModalConfirm.vue";
import LogOutBtn from "../common/LogOutBtn.vue";
import GameItem from "./games/Game.vue";
// Import services
import { createGame, deleteGame } from "@/services/backends/games";

@Component({
  components: {
    List,
    ModalForm,
    ModalConfirm,
    GameItem,
    LogOutBtn
  }
})
export default class Games extends Vue {
  private gameCreation = false;
  private newGameName = "New game";

  play(gameId: string): void {
    this.$router.push({ name: "Board", params: { gameId } });
  }

  $refs!: {
    confMod: ModalConfirm;
  };

  async del(gameId: string): Promise<void> {
    if (!this.$refs.confMod) return;

    const ok = await this.$refs.confMod.show({
      title: "Delete Game?",
      message: "It cannot be undone.",
      okButton: "Delete"
    });

    if (ok) {
      await deleteGame(gameId);
      this.$emit("refreshGames");
    }
  }

  async createGame(): Promise<void> {
    await createGame(this.newGameName);
    this.gameCreation = false;
    this.$emit("refreshGames");
  }
}
</script>

<style scoped>
#Games {
  height: 100%;
  display: flex;
  flex-direction: column;
}

#exitBtn {
  margin-right: 10px;
}

#title {
  display: flex;
  justify-content: space-between;
  align-items: center;
}

#gameList {
  align-self: center;
  display: flex;
  flex-direction: column;
  width: 50%;
  min-width: 450px;
  margin-top: 10px;
  overflow-y: auto;
  overflow-x: hidden;
}

#gameCreation {
  display: flex;
  flex-direction: column;
  gap: 10px;
}
#gameCreation #btns {
  padding-top: 20px;
  display: flex;
  justify-content: space-around;
}
</style>
